import 'dart:async';
import 'dart:convert';

import 'package:universal_io/io.dart';

import 'io_driver_browser.dart' show ZoneLocal, PlatformInfo;

class IODriver {
  static final ZoneLocal<IODriver> zoneLocal =
      new ZoneLocal<IODriver>(defaultValue: new IODriver());

  static IODriver get current {
    return zoneLocal.current;
  }

  final PlatformInfo platformInfo;

  IODriver({this.platformInfo = const PlatformInfo()});

  bool get isWatchSupported => throw new UnimplementedError();

  Stdout get stderr {
    throw new UnimplementedError();
  }

  Stdin get stdin {
    throw new UnimplementedError();
  }

  Stdout get stdout {
    throw new UnimplementedError();
  }

  Directory get systemTemp {
    throw new UnimplementedError();
  }

  Future<RawDatagramSocket> bindRawDatagramSocket(host, int port,
      {bool reuseAddress: true, bool reusePort = false, int ttl = 1}) {
    throw new UnimplementedError();
  }

  Future<RawServerSocket> bindRawServerSocket(address, int port,
      {int backlog: 0, bool v6Only = false, bool shared = false}) {
    throw new UnimplementedError();
  }

  Future<ServerSocket> bindServerSocket(address, int port,
      {int backlog: 0, bool v6Only = false, bool shared = false}) {
    throw new UnimplementedError();
  }

  Future<RawSocket> connectRawSocket(host, int port,
      {sourceAddress, Duration timeout}) {
    throw new UnimplementedError();
  }

  Future<Socket> connectSocket(host, int port,
      {sourceAddress, Duration timeout}) {
    throw new UnimplementedError();
  }

  Future<List<NetworkInterface>> listNetworkInterfaces(
      {bool includeLoopback: false,
      bool includeLinkLocal: false,
      InternetAddressType type = InternetAddressType.any}) {
    throw new UnimplementedError();
  }

  Future<List<InternetAddress>> lookupInternetAddresses(String host,
      {InternetAddressType type = InternetAddressType.any}) {
    throw new UnimplementedError();
  }

  Directory newDirectory(String path) {
    throw new UnimplementedError();
  }

  File newFile(String path) {
    throw new UnimplementedError();
  }

  FileSystemEntity newFileSystemEntity(String path) {
    throw new UnimplementedError();
  }

  InternetAddress newInternetAddress(String value) {
    throw new UnimplementedError();
  }

  Link newLink(String path) {
    throw new UnimplementedError();
  }

  Future<InternetAddress> reverseLookupInternetAddress(
      InternetAddress address) {
    throw new UnimplementedError();
  }

  Future<ProcessResult> run(String executable, List<String> arguments,
      {String workingDirectory,
      Map<String, String> environment,
      bool includeParentEnvironment = true,
      bool runInShell = false,
      Encoding stdoutEncoding = systemEncoding,
      Encoding stderrEncoding = systemEncoding}) {
    throw new UnimplementedError();
  }

  ProcessResult runSync(String executable, List<String> arguments,
      {String workingDirectory,
      Map<String, String> environment,
      bool includeParentEnvironment = true,
      bool runInShell = false,
      Encoding stdoutEncoding = systemEncoding,
      Encoding stderrEncoding = systemEncoding}) {
    throw new UnimplementedError();
  }

  Future<Process> start(String executable, List<String> arguments,
      {String workingDirectory,
      Map<String, String> environment,
      bool includeParentEnvironment = true,
      bool runInShell = false,
      ProcessStartMode mode = ProcessStartMode.normal}) {
    throw new UnimplementedError();
  }

  Future<ConnectionTask<RawSocket>> startConnectRawSocket(host, int port,
      {sourceAddress}) {
    throw new UnimplementedError();
  }

  Future<ConnectionTask<Socket>> startConnectSocket(host, int port,
      {sourceAddress}) {
    throw new UnimplementedError();
  }
}
